using System;

using Rhino;
using Rhino.Commands;

namespace RhinoCodePlatform.Rhino3D.Projects.Plugin
{
  [CommandStyle(Rhino.Commands.Style.ScriptRunner)]
  public class ProjectCommand_b12ba98d : Command
  {
    public Guid CommandId { get; } = new Guid("b12ba98d-f8a2-4dcd-942f-6a5f0e322887");

    public ProjectCommand_b12ba98d() { Instance = this; }

    public static ProjectCommand_b12ba98d Instance { get; private set; }

    public override string EnglishName => "w_loft_mesh";

    protected override Rhino.Commands.Result RunCommand(RhinoDoc doc, RunMode mode)
    {
      // NOTE:
      // Initialize() attempts to loads the core rhinocode plugin
      // and prepare the scripting platform. This call can not be in any static
      // ctors of Command or Plugin classes since plugins can not be loaded while
      // rhino is loading this plugin. The call has an initialized check and is
      // very fast after the first run.
      ProjectPlugin.Initialize();

      return ProjectPlugin.RunCode(this, CommandId, doc, mode);
    }
  }
}
