using System;

using Rhino;
using Rhino.Commands;

namespace RhinoCodePlatform.Rhino3D.Projects.Plugin
{
  [CommandStyle(Rhino.Commands.Style.ScriptRunner)]
  public class ProjectCommand_c3fa9ccf : Command
  {
    public Guid CommandId { get; } = new Guid("c3fa9ccf-ee62-45b7-92e6-b30473390737");

    public ProjectCommand_c3fa9ccf() { Instance = this; }

    public static ProjectCommand_c3fa9ccf Instance { get; private set; }

    public override string EnglishName => "w_solver";

    protected override Rhino.Commands.Result RunCommand(RhinoDoc doc, RunMode mode)
    {
      // NOTE:
      // Initialize() attempts to loads the core rhinocode plugin
      // and prepare the scripting platform. This call can not be in any static
      // ctors of Command or Plugin classes since plugins can not be loaded while
      // rhino is loading this plugin. The call has an initialized check and is
      // very fast after the first run.
      ProjectPlugin.Initialize();

      return ProjectPlugin.RunCode(this, CommandId, doc, mode);
    }
  }
}
